<template>
  <div class="container  mt-5">
    <div class="card">

      <div class="card-header">
        <h4>Movies
          <RouterLink to="/movies/create" class="btn btn-primary float-end">Add Movie</RouterLink>
        </h4>
      </div>

      <div class="card-body my-card">
        <table class="table table-bordered">
          <thead>
            <th width="12%">#</th>
            <th width="23%">Name</th>
            <th width="45%">Description</th>
            <th>Action</th>
          </thead>
          <tbody v-if="this.movies.length > 0">
            <tr v-for="(movie, index) in this.movies" :key="index">
              <td>{{ movie.id }}</td>
              <td>{{ movie.name }}</td>
              <td>{{ movie.description }}</td>
              <td>
                <RouterLink :to="{ path: '/movies/' + movie.id + '/edit' }" class="btn btn-success mx-2 action">Edit
                </RouterLink>
                <button type="button" @click="deleteMovie(movie.id)" class="btn btn-danger mx-2 action">Delete</button>
              </td>
            </tr>
          </tbody>
          <tbody v-else>
            <tr>
              <td colspan="4">Loding...</td>
            </tr>
          </tbody>
        </table>
      </div>

    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'movies',
  data() {
    return {
      movies: []
    }
  },
  mounted() {
    this.getMovies();
  },
  methods: {
    getMovies() {
      axios.get('http://localhost:8000/api/movies', {
        headers: {
          'Authorization': localStorage.getItem('token'),
          'Accept': 'application/json'
        }
      }).then(res => {
        console.log(res.data);
        this.movies = res.data.data;
      });
    },

    deleteMovie(movieId) {
      console.log(movieId);
      if (confirm('Are you sure, you want to delete this data?')) {
        axios.delete(`http://localhost:8000/api/movies/${movieId}/delete`, {
          headers: {
            'Authorization': localStorage.getItem('token'),
            'Accept': 'application/json'
          }
        }).then(res => {
          alert(res.data.message);
          this.getMovies();
        }).catch(function (error) {
          if (error.response) {
            if (error.response.status == 404) {
              // $this.errorList = error.response.data.errors;
              alert(error.response.data.message);
            }
          }
        });
      }
    }
  },

}

</script>

<style>
.my-card {
  max-height: 70vh;
  height: 70vh;
  overflow: auto;
}

thead,
tbody,
tfoot,
tr,
td,
th {
  border-width: 1px !important;
}

th,
td {
  text-align: center;
}

th {
  background: #474646;
  color: white;
  height: 40px;
  vertical-align: middle;
}

.btn-primary,
.btn-primary:hover,
.btn-primary:focus-visible {
  background: #474646 !important;
  border-color: #474646 !important;
}

.action {
  width: 40%;
}

/* smooth scrollbar */

/* scrollbar width and height */
::-webkit-scrollbar {
  width    : 6px;
  height   : 3px;
}

/* scroll bar style */
::-webkit-scrollbar-track-piece {
  background-color: darkgray;
  border-radius   : 36px;
}

/* scroll bar (scroller) style */
::-webkit-scrollbar-thumb {
  height          : 50px;
  background-color: #474646;
  border-radius   : 36px;
}

</style>
